
local _,classFileName=UnitClass("player");
if classFileName ~= "SHAMAN" then return end


WindchimeDB = {}
local Windchime = CreateFrame("Frame")

function Windchime:Load()
	SlashCmdList["WINDCHIMESLASH"] = Windchime_SlashCommands
	SLASH_WINDCHIMESLASH1 = "/windchime"
  	SLASH_WINDCHIMESLASH2 = "/wc"

	self:SetScript("OnEvent",function(self, event, _, _, _, _, arg5, _, _, _, _, _, _, arg12)
		if event == "COMBAT_LOG_EVENT_UNFILTERED" then
			if arg12 == 25504 then
				if arg5 == UnitName('player') then
					self.bar1.countdown = 3
					self.bar1:Show()
				end
			end
		elseif event == "ADDON_LOADED" then
			self:UnregisterEvent("ADDON_LOADED")
			if WindchimeDB.x then
				self.bar1:ClearAllPoints()
				self.bar1:SetPoint("BOTTOMLEFT",nil,"BOTTOMLEFT",WindchimeDB.x,WindchimeDB.y)
			end
		end
	end)
	self:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
	self:RegisterEvent("ADDON_LOADED")

	self.bar1 = self:CreateTimerBar(5, 1, 0, 0, 0.8)
end

function Windchime:CreateTimerBar(level, red, green, blue, alpha)
	local bar = CreateFrame("StatusBar",nil,UIParent,"TextStatusBar")
	bar:SetWidth(90) -- edit here to change bar width.
	bar:SetHeight(36) -- here is height
	bar:SetMovable(1)
	if alpha == 1 then
		bar:SetBackdrop({bgFile = "Interface\\Tooltips\\UI-Tooltip-Background", tile = true, tileSize = 16})
		bar:SetBackdropColor(0,0,0,1)
		bar:SetPoint("TOPLEFT",self.bar1,"TOPLEFT")
	else
		bar:SetPoint("CENTER",0,-100) -- edit X/Y offsets here to move the bar.
	end
	bar:SetStatusBarTexture("Interface\\TargetingFrame\\UI-StatusBar")
	bar:SetStatusBarColor(red,green,blue)
	bar:SetMinMaxValues(0,3)
	bar:SetAlpha(alpha)
	bar:SetFrameLevel(level)

	bar.text = bar:CreateFontString(nil, "OVERLAY", "ChatFontSmall")
	bar.text:SetAlpha(alpha)
	bar.text:SetPoint("TOPLEFT")
	bar.text:SetPoint("BOTTOMRIGHT")
	if alpha == 1 then
		bar.text:SetJustifyH("RIGHT")
	else
		bar.text:SetJustifyH("LEFT")
	end

	bar.countdown = 0
	bar:SetScript("OnUpdate",function(self,elapsed)
		self.countdown = self.countdown - elapsed
		if self.countdown > 0 then
			self:SetValue(self.countdown)
			self.text:SetText(string.format("%.1f",self.countdown))
		else
			self:Hide()
		end
	end)

	return bar
end

function Windchime_SlashCommands(msg)
	if Windchime.bar1:IsVisible() then
		Windchime.bar1:Hide()
		Windchime.bar1:SetScript("OnMouseDown",nil)
		Windchime.bar1:SetScript("OnMouseUp",nil)
	else
		Windchime.bar1.countdown = 9999
		Windchime.bar1:SetScript("OnMouseDown", function(self) self:StartMoving() end)
		Windchime.bar1:SetScript("OnMouseUp", function(self)
			self:StopMovingOrSizing()
			local x,y = self:GetRect()
			WindchimeDB.x,WindchimeDB.y = x, y
		end)
		Windchime.bar1:Show()
	end
end

Windchime:Load()
